/////////////////////////////////////////////////////////////////////////////////////////////
// (c) Copyright 2009 - Analog Devices, Inc.                                               //
//                                                                                         //
// NAME:     main.c (sample-based Talkthrough)                                             //
// DATE:     02/06/10                                                                      //
// PURPOSE:  Function main() for AD1939/ADSP-21489 Talkthrough framework.                  //
//                                                                                         //
// USAGE:    This file contains the main routine calls functions to set up the talkthrough //
//           routine.                                                                      //
//                                                                                         //
//                                                                                         //
// Author:   VS., Analog Devices, Inc                                                 //
//                                                                                         //
/////////////////////////////////////////////////////////////////////////////////////////////

#include "ADDS_21489_EzKit.h"
#include "interrupts.h"

float * DelayLine;

int Index  = 0;
int Sine_Index = 0;
int SPORT1_isr_count = 0;
int SPORT0_isr_count = 0;

void SPORT1_isr_counter(void);
void SPORT0_isr_counter(void);


void main(void)
{
	// Initialize DAI because the SPORT and SPI signals
	// need to be routed
	InitDAI();

	// This function will configure the AD1939 codec on the 21489 EZ-KIT
	Init1939viaSPI();

	// Turn on SPORT0 TX and SPORT1 RX for Multichannel Operation
	enable_SPORT01_MCM_mode();

	// Unmask SPORT1 RX ISR Interrupt
	irq_assign_set(PIRQ_SRC_SP1I, PVECT_3);
	irq_install(PVECT_3, process_AD1939_samples);

	*pSPMCTL0 |= MCEA;
	*pSPMCTL1 |= MCEA;

	SinTableInit();

	// Set up small delay buffer
	DelayLine = (float *) 0x000C4000;

	for (;;)
	{
		asm("idle;");
	}
}

